#!/bin/sh

cd `dirname $0`

if [ -r ./js.cfg ]
then
    . ./js.cfg
else
    echo >&2 "Le fichier js.cfg n'existe pas ou n'est pas lisible"
    exit 1
fi

case "`uname -s`" in
    Linux) CronArgs="-" ;;
    *) ;;
esac

[ -e conf-cron-local.sh ] && . ./conf-cron-local.sh

[ -z "$Report" ] && Report="$USER@localhost"
[ -z "$RepUpr" ] && RepUpr=`pwd`

(
for upr in $ListeUPR
do
    [ "$upr" = "OK" ] && continue # pas de lancement de OK
    eval echo \$${upr}_TSK | tr ';' '\n' | while read arg
    do
        Date=`echo $arg | sed "s/.*(\(.*\)).*/\1/"`
        case "$arg" in
            "impl add rule="*)
                Cal=`echo "$Date" | cut -d, -f1`
                StartDate=`echo "$Date" | cut -d, -f2`
                case "$Cal" in
                    TV4_J) DateJS="* * *" ;;
                    DIMANCHE) DateJS="* * 0" ;;
                    *) echo >&2 "Date non reconnue : $Cal" ;;
                esac
                ;;
            "time dalw="*)
                Time=`echo "$Date" | cut -d"," -f1`
                Hh=`echo "$Time" | sed "s/^\([0-9][0-9]\)\([0-9][0-9]\)$/\1/"`
                Mn=`echo "$Time" | sed "s/^\([0-9][0-9]\)\([0-9][0-9]\)$/\2/"`
                Time="$Mn $Hh"
                ;;
            "time mulw="*)
                StartTime=`echo "$Date" | cut -d"," -f1`
                StartHh=`echo "$StartTime" | sed "s/^\([0-9][0-9]\)\([0-9][0-9]\)$/\1/"`
                StartMn=`echo "$StartTime" | sed "s/^\([0-9][0-9]\)\([0-9][0-9]\)$/\2/"`
                EndTime=`echo "$Date" | cut -d"," -f2`
                Freq=`echo "$Date" | cut -d"," -f3 | sed "s/).*//"`
                if [ `expr 60 % $Freq` -ne 0 ]
                then
                    echo >&2 "Il faut que la frequence (ici $Freq) soit un multiple de 60"
                    break
                fi
                i="$StartMn"
                Mn=""
                while [ $i -lt 60 ]
                do
                    [ -z "$Mn" ] && Mn="$i" || Mn="$Mn,$i"
                    i=`expr $i + $Freq`
                done
                Time="$Mn *"
                ;;
            techinf*) ;;
            *) echo >&2 "Option non reconnue : $arg" ;;
        esac
        if [ -n "$Time" -a -n "$DateJS" ]
        then
            cat << EOF
$Time $DateJS (STATUT="FAILED" ; $RepUpr/$upr.000 > /tmp/js.\$\$ 2>&1 && STATUT="OK" ; mail -s "[JS on $Hostname] UPR $upr \$STATUT" $Report < /tmp/js.\$\$ || echec-cron.sh ; rm -f /tmp/js.\$\$)
EOF
            Time=""
            DateJS=""
        fi
    done
done
crontab -l | egrep -v "^#|\[JS on .*\]"
) | crontab $CronArgs
